(function(){
  var Mixin = function(){
    if(!this._mixin){
      this._mixin = [];
      this._mixin.api = {};
    }
    var process_item = function(key,value){
      var should_add = true;
      var discard = function(){
        should_add = false;
      };
      if(key == 'mixin'){
        for(var _key in value){
          this._mixin.api[_key] = value[_key];
        }
      }else{
        if(this._mixin.api[key]){
          this._mixin.api[key].apply(this,[value,discard]);
        }else{
          this[key] = value;
        }
        if(should_add){
          this._mixin.push([key,value]);
        }
      }
    };
    for(var i = 0; i < arguments.length; ++i){
      if(arguments[i] && arguments[i]._mixin && arguments[i]._mixin.length){
        for(var ii = 0; ii < arguments[i]._mixin.length; ++ii){
          process_item.apply(this,arguments[i]._mixin[ii]);
        }
      }else{
        for(var key in arguments[i]){
          process_item.apply(this,[key,arguments[i][key]]);
        }
      }
    }
  };
  if(typeof module !== 'undefined' && typeof module.exports !== 'undefined'){
    module.exports = Mixin;
  }else{
    this.Mixin = Mixin;
  }
  if(this.ender){
    this.ender.ender({
      mixin: Mixin
    });
  }
}).call(this);