var assert = require('assert');
var mixin = require('./mixin.js');
var MyMixin = {
  mixin: mixin
};

MyMixin.mixin({
  key: 'value'
});

MyMixin.mixin({
  mixin: {
    add: function(number){
      this.number = number + 1;
    }
  }
});

MyMixin.mixin({
  add: 1
});

assert.equal(MyMixin.number,2);
assert.equal(MyMixin.key,'value');